%%% OPERATORS

:- op(300,xfx,'--'). % open list operator
:- op(400,xfy,'$').  % category/features pair operator, used to be xfx
:- op(701,xfy,'$$'). % right hop operator, outside =
:- op(800,fx,'?').

%%:- op(1000,xfy,',').		% platform-specific
:- op(960,xf,preserved).
:- op(950,xfy,iff).
:- op(950,xfy,if).
:- op(950,xfy,unless).
:- op(801,fx,when).
:- op(800,xfx,do).
:- op(950,xfy,eliminates).
:- op(950,xfx,shortcuts).
:- op(950,xfx,for_all).
:- op(900,fx,check).
%  op(900,fy,'\+').
:- op(800,fx,no).
:- op(800,xfx,unique_feature_in).
:- op(800,xfx,unique_category_in).
:- op(800,fx,unique_feature_domain).
:- op(800,xfx,bound_to).
:- op(800,xfx,contains).
:- op(800,xfx,containsF).
:- op(800,xfx,containsFs).
:- op(800,xfx,contains_set).
:- op(800,xfx,has_features).
:- op(800,xfx,has_pnfeatures).
:- op(800,xfx,has_pdfeatures).
:- op(800,xfx,has_constituents).
:- op(800,xfx,has_constituent).
:- op(800,xfx,dominates).
:- op(800,xfx,ldominates).
:- op(800,xfx,dominates_noMax).			% obsolete
:- op(800,xfx,has_same_features_as).
:- op(800,xfx,shares_features_with).
:- op(800,xfx,shares_pdfeatures_with).
:- op(800,xfx,shares_pnfeatures_with).
:- op(800,xfx,shares_pfeatures_with).
:- op(800,xfx,shares_category_with).
:- op(800,xfx,shares_category_and_features_with).
:- op(800,xfx,shares_constituents_with).
:- op(710,xfx,thread).
:- op(701,fx,make).
:- op(701,fx,assume).
%  op(799,xfx,=)
:- op(700,xfx,has_id).
:- op(700,xfx,has_feature).
:- op(700,xfx,has_role_name).
:- op(700,xfx,have_feature).
:- op(750,xfx,with_constraint).
:- op(700,xfx,has_intrinsic_feature).
:- op(700,xfx,has_feature_set).
:- op(700,xfx,has_feature_set1).
:- op(700,xfx,in).
:- op(700,fx,satisfies).

%%% OPERATOR DEFINITIONS NECESSARY FOR RULE/1

:- op(1080,fx,block).
:- op(1070,fx,non_config).
:- op(1070,fx,adjunction).
:- op(1070,fx,left_bracket).
:- op(1070,fx,right_bracket).
:- op(1070,fx,bracket).
:- op(1070,fx,local).
:- op(1060,fx,rule).
:- op(1060,fx,hmrule).
:- op(1050,xfx,provided).
:- op(1050,xfx,provided_iff).
%  op(1050,xfy,->).   built-in
%:- op(1040,xfx,st).
:- op(1040,xfx,add_option).
:- op(1040,xfx,nonlocal_option).
:- op(1040,xfx,idominated_by).
:- op(1040,xfx,for).
:- op(1030,xfx,ordered).
:- op(1030,xfx,by).
:- op(1030,xfx,with).
:- op(1060,xfx,add_goals).
:- op(1060,xfx,replace_goal).
:- op(1060,xfx,replace_rhs).
:- op(1060,xfx,app_goals).
:- op(1060,xfx,substitute).
:- op(1060,xfx,add_inherit).
:- op(1050,xfy,'&').
:- op(1038,fx,anywhere).
:- op(1045,fx,lhs).
:- op(1045,fx,rhs).
%:- op(1000,xfy,',').		% platform-specific
:- op(950,fx,post_cond).
%  op(900,fy,'\+').

%%% OPERATOR DEFINITIONS FOR PRINCIPLES

% NB. Can't have anything > 12000
% :- op(1200,fx,:-).	built-in
:- op(1200,fy,within).
:- op(1154,xfx,with_clause).
:- op(1152,xf,prepended).
:- op(1152,xf,appended).
:- op(1154,xfx,append_lists).
:- op(1152,xfx,produced_by).
:- op(1150,xfx,in_all_configurations).
:- op(1150,xfx,exists_some_configuration).
:- op(1150,xfx,smallest_configuration).
:- op(1150,xfy,collect).
:- op(1150,xfx,collect_all_configurations).
:- op(1150,xfx,parameterized_by).
:- op(1150,xfx,cases).
:- op(1150,xfx,top).
:- op(1150,xfx,parser_operation).
:- op(1150,xfx,each).
:- op(1150,xfx,those).
:- op(1150,xfx,exists).
:- op(1150,fx,exists).
:- op(1149,xfx,where).
:- op(1149,xfx,with_components).
:- op(1148,xfy,else).
:- op(1147,xfx,finally).
:- op(1146,xfx,then).
:- op(1145,fx,must_satisfy).
:- op(1144,xfx,on).
:- op(1144,xfx,using).
:- op(1110,xfx,satisfies).
:- op(1110,xfx,satisfying).
:- op(1108,xfx,substitutes_for).
%:- op(700,xfx,in).
%%:- op(1100,xfy,';').		% platform-specific
:- op(1040,xfx,st).
:- op(1040,xfx,under).
%%:- op(1000,xfy,',').		% platform-specific
:- op(970,fx,reanalyze).
:- op(950,xfx,preserving_invariant).
:- op(950,fx,assuming).
:- op(950,xfx,assume).
:- op(950,xfx,copy_of).
:- op(945,xfx,to_be).
:- op(945,xfx,as).
:- op(940,xfx,over).
:- op(950,xf,holds).
:- op(920,fx,extract).
:- op(920,xfx,extract).
:- op(900,xfx,opaque_when).
:- op(910,xfx,producing).
:- op(900,xfx,from).
:- op(905,xfx,given_by).
:- op(900,xfx,produces).
:- op(898,xfx,excluding).
:- op(800,fx,uses_env).
:- op(800,xfx,using_env).
:- op(800,xfx,with_constituents).
:- op(800,xfx,has_components).
:- op(710,xfx,and).
:- op(700,xfx,'->>').
:- op(700,fx,multiple).
:- op(700,fx,opaque).
:- op(700,xf,doesnt_move).
:- op(750,fx,head_adjoined).
:- op(700,xfx,adjoins_to_the).
:- op(700,xfx,add_feature).
:- op(700,xfx,add_features).
:- op(700,xfx,check_feature).
:- op(700,xfx,check_features).
:- op(700,xfy,moves_to).
:- op(700,xfy,moves_through).
:- op(700,yfx,derived_from).
:- op(700,fx,empty).
:- op(650,xfx,to).
:- op(800,xfx,head_of).
:- op(800,xfx,projection_of).
:- op(800,xfx,immed_projection_of).
:- op(800,xfx,nonprojection_of).
:- op(800,xfx,immed_nonprojection_of).
:- op(800,xfx,complement_of).
:- op(800,xfx,immed_complement_of).
:- op(800,xfx,subcategorizes_for).
:- op(800,xfx,immed_subcategorizes_for).
:- op(800,xfx,specifier_of).
:- op(800,xfx,immed_specifier_of).
:- op(800,xfx,subject_of).
:- op(800,xfx,adjunct_of).
:- op(800,xfx,iDominates_head).
:- op(800,xfx,subcat_by).
:- op(800,xfx,is_substituting_for).
:- op(700,xf,immediate).
